import javax.xml.parsers.*;
import org.w3c.dom. *;

public class Course {
	public static void main(String[] args) throws Exception {
		//factory instantiation
		//factory API that enables applications to obtain a parser that
		//produces DOM object trees from XML documents
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

		//validation and namespaces
		factory.setValidating(true);
		factory.setNamespaceAware(true);

		//parser instantiation
		//API to obtain DOM document instances from XML documents
		DocumentBuilder builder = factory.newDocumentBuilder();

		//install ErrorHandler
		builder.setErrorHandler(new MyErrorHandler());

		//parsing instantiation
		Document coursedoc = builder.parse(args[0]);
		
		
		
		//call visit node starting from the root node
		visitNode(coursedoc.getDocumentElement()); 
	}
	
	//the recursive method visitNode 
		private static void visitNode(Node node) { 
			//element nodes
			if (node.getNodeType() == Node.ELEMENT_NODE ) {
				System.out.print("\n" + node.getNodeName() + ": ");
				
				NamedNodeMap attributes = node.getAttributes();
				if (attributes != null) {
					for (int i = 0; i < attributes.getLength(); i++) {
						System.out.print(attributes.item(i) + " ");
					}
				}
			
			}
			
			//text nodes
			if (node.getNodeType() == Node.TEXT_NODE && !node.getTextContent().trim().isEmpty()) {
				System.out.print("\"" + node.getTextContent().trim() + "\"");
			}
			
			// visit child nodes
			NodeList nodeList = node.getChildNodes();
			for (int i = 0; i < nodeList.getLength(); i++) {
				visitNode(nodeList.item(i));
			}
			
		}
} //end of Course class