import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class CourseCreate {
	public static void main(String[] args) throws Exception { 
		//factory instantiation
		//factory API that enables applications to obtain a parser that
		//produces DOM object trees from XML documents
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

		//validation and namespaces
		factory.setValidating(true);
		factory.setNamespaceAware(true);

		//parser instantiation
		//API to obtain DOM document instances from XML documents
		DocumentBuilder builder = factory.newDocumentBuilder();

		//install ErrorHandler
		builder.setErrorHandler(new MyErrorHandler());
		
		//create a new document Document
		Document coursedoc = builder.newDocument(); 
		
		//create all the necessary elements 
		Element courses = coursedoc.createElement("courses"); 
		Element course = coursedoc.createElement("course");
		course.setAttribute("semester", "Summer"); 
		Element title = coursedoc.createElement("title"); 
		title.setTextContent("Semi-structured Data (SSD)"); 
		//similarly for day, time and location elements
		Element day = coursedoc.createElement("day");
		day.setTextContent("Thursday");
		Element time = coursedoc.createElement("time");
		time.setTextContent("09:15");
		Element location = coursedoc.createElement("location");
		location.setTextContent("HS8");
		
		
		//append the children in a bottom-up-order
		course.appendChild(title); 
		course.appendChild(day);
		course.appendChild(time); 
		course.appendChild(location);
		courses.appendChild(course);
		coursedoc.appendChild(courses);
		
		//Store Document in file course-01.xml
		TransformerFactory tFactory = TransformerFactory.newInstance();
		Transformer transformer = tFactory.newTransformer();
		DOMSource source = new DOMSource(coursedoc);
		StreamResult result = new StreamResult(new File("resources/course-01.xml"));
		transformer.transform(source, result);
	}
}
