import org.xml.sax.*;

public class MyErrorHandler implements ErrorHandler {
	public void fatalError(SAXParseException ex) throws SAXException {
		printError("FATAL ERROR", ex);
	}
	
	public void error(SAXParseException ex) throws SAXException {
		printError("ERROR", ex);
	}
	
	public void warning(SAXParseException ex) throws SAXException {
		printError("WARNING", ex);
	}
	
	private void printError(String err, SAXParseException ex) {
		System.out.printf("%s at %3d, %3d: %s \n", err, ex.getLineNumber(), ex.getColumnNumber(), ex.getMessage());
}
} // end of MyErrorHansder class